compare/urls.py
from django.urls import path

from . import views

app_name = 'compare'
urlpatterns = [
    path('', views.index, name='index'),
    path('results/', views.results, name='results'),
    path('<product>/details/', views.details, name='details'),
    path('signup/', views.signup, name='signup'),
    path('signin/', views.signin, name='signin'),
    path('signout/', views.signout, name='signout'),
    path('account/', views.account, name='account'),
    path('<product>/bookmark/', views.bookmark, name='bookmark'),
    path('<product>/product/', views.product_page, name='product'),
    path('mentions/', views.mentions, name='mentions'),
]

compare/models.py
from math import ceil

from django.contrib.auth.models import User
from django.db import models


class Categorie(models.Model):
    id_categorie = models.CharField(max_length=80, primary_key=True)
    name = models.CharField(max_length=80, null=True)
    url = models.CharField(max_length=255, null=True)
    products_nb = models.IntegerField(null=True)

    def __str__(self):
        return self.name


class Product(models.Model):
    id_product = models.CharField(max_length=80, primary_key=True)
    product_name = models.CharField(max_length=80, null=True)
    nutrition_grade_fr = models.CharField(
        "nutriscore", max_length=1, null=True)
    energy = models.FloatField(max_length=10, null=True)
    brands = models.CharField(max_length=80, null=True)
    stores = models.CharField(max_length=80, null=True)
    url = models.URLField(max_length=255, null=True)
    image_url = models.URLField(max_length=255, null=True)
    categorie = models.ForeignKey("Categorie", on_delete=models.CASCADE)

    def kcal(self):
        return ceil(self.energy / 4.184)

    def __str__(self):
        return self.product_name


class Bookmark(models.Model):
    id_result = models.ForeignKey("Product", on_delete=models.CASCADE)
    user = models.ForeignKey(User, on_delete=models.CASCADE)

compare/forms.py
from django import forms


class Sign(forms.Form):
    email = forms.EmailField(
        label='Email',
        widget=forms.EmailInput(
            attrs={'class': 'form-control', 'placeholder': 'Adresse e-mail'}),
        required=True,
    )

    password = forms.CharField(
        label='Mot de passe',
        widget=forms.PasswordInput(
            attrs={'class': 'form-control', 'placeholder': 'Mot de passe'}),
        required=True)

compare/views.py
import logging

from random import choice

from django.contrib.auth import authenticate, login, logout
from django.contrib.auth.decorators import login_required
from django.contrib.auth.models import User
from django.shortcuts import get_object_or_404, redirect, render
from django.http import Http404

from compare.facts import DbRead

from .forms import Sign
from .models import Bookmark, Product

# Instance of logger
logger = logging.getLogger(__name__)
logger.setLevel(logging.INFO)

# Get random background
def background():
    return choice(['bg-greg-jeanneau-unsplash.jpg',
                   'bg-kawin-harasai-unsplash.jpg',
                   'bg-olenka-kotyk-unsplash.jpg', ])


def index(request):
    context = {
        'background': background(),
    }
    return render(request, 'compare/index.html', context)


def results(request):
    # Clear checkbox session variables
    request.session['grade'] = None
    request.session['energy'] = None

    query_result = DbRead.search_product(request.POST['product'])

    if 'grade' in request.POST:
        request.session['grade'] = request.POST['grade']
    if 'energy' in request.POST:
        request.session['energy'] = request.POST['energy']

    context = {
        'query': query_result,
        'background': background(),
    }

    return render(request, 'compare/results.html', context)


def details(request, product):
    user_filter = (request.session.get('grade'), request.session.get('energy'))

    try:
        product_selected, product_substitute = DbRead.get_substitute(
            product, *user_filter)
    except Product.DoesNotExist:
        raise Http404

    context = {
        'product': product_substitute,
        'product_selected': product_selected,
        'background': background(),
    }

    logger.info('Product selected', extra={
        'product_selected': product_selected,
        'product_substitute': product_substitute,
    })

    if not product_substitute:
        context['user_result'] = 'Pas de substitut trouvé pour ce produit.'

    return render(request, 'compare/details.html', context)


def signup(request):
    form = Sign()
    context = {
        'form': form,
        'background': background(),
    }

    if request.method == 'POST':
        form = Sign(request.POST)

        if form.is_valid():
            email = form.cleaned_data['email']
            password = form.cleaned_data['password']

            if not User.objects.filter(username=email):
                user = User.objects.create_user(email, email, password)

                # Authenticate and login user after registration.
                user = authenticate(username=form.cleaned_data['email'],
                                    password=form.cleaned_data['password'],)

                login(request, user)
                context['user_result'] = "Le compte a été créé !"
                return render(request, 'compare/form_signin.html', context)

            else:
                context['user_result'] = "L'utilisateur existe déjà."

        else:
            context = {'form': form}

    return render(request, 'compare/form_signup.html', context)


def signin(request):
    form = Sign()

    nextvalue = request.GET.get('next')

    context = {
        'form': form,
        'background': background(),
        'next': nextvalue,
    }

    if request.user.is_authenticated and nextvalue is not None:
        return redirect(nextvalue)

    else:
        if request.method == 'POST':
            form = Sign(request.POST)
            if form.is_valid():
                user = authenticate(username=form.cleaned_data['email'],
                                    password=form.cleaned_data['password'],)
                if user is not None:
                    login(request, user)
                    if nextvalue is not None:
                        return redirect(nextvalue)
                    else:
                        return redirect('compare:account')
                else:
                    context['user_result'] = 'Identification invalide.'
                    return render(request, 'compare/form_signin.html', context)
            else:
                context = {
                    'form': form,
                    'user_result': 'Identification invalide.',
                    'next': nextvalue,
                }

    return render(request, 'compare/form_signin.html', context)


def signout(request):
    if not request.user.is_authenticated:
        return redirect('compare:signin')
    logout(request)
    return redirect('compare:index')


@login_required(login_url='/compare/signin/')
def account(request):

    user_authenticated = User.objects.get(pk=request.user.id)
    product_in_bookmark = Bookmark.objects.filter(
        user=user_authenticated)

    context = {
        'user_result': 'Vous êtes déconnecté⋅e.',
        'products': product_in_bookmark,
        'background': background(),
    }

    return render(request, 'compare/account.html', context)


@login_required(login_url='/compare/signin/')
def bookmark(request, product):

    context = {
        'background': background(),
    }

    user_authenticated = User.objects.get(pk=request.user.id)
    product_subtitute = Product.objects.get(id_product=product)

    product_in_bookmark = Bookmark.objects.filter(
        user=user_authenticated
    ).filter(
        id_result=product_subtitute
    ).exists()

    if not product_in_bookmark:
        add_bookmark = Bookmark(
            id_result=product_subtitute, user=user_authenticated)
        add_bookmark.save()
        return redirect('compare:account')
    else:
        context['user_result'] = "Ce produit a déjà été\
             enregristré dans les favoris."

    return render(request, "compare/details.html", context)


def product_page(request, product):
    get_product = get_object_or_404(Product, id_product=product)

    context = {
        'product': get_product,
        'background': background(),
    }

    return render(request, 'compare/product.html', context)


def mentions(request):
    context = {
        'background': background(),
    }

    return render(request, 'compare/mentions.html', context)

compare/templates/compare/account.html
{% extends 'compare/base.html' %}

{% block content %}

{% include 'compare/header.html' %}

<section class="page-section" id="services">
    <div class="container">
        <h2 class="text-center mt-0">Produits favoris</h2>
        <hr class="divider my-4">
        <div class="row justify-content-center">
            <div class="col-lg-7 col-md-6 ">
                <div class="mt-5">
                    {% if products %}
                    <p>Liste des favoris.</p>
                    {% for product in products  %}
                    <li>
                        <a href="{% url 'compare:product' product.id_result_id %}">
                            {{ product.id_result.product_name }} - {{ product.id_result.brands }}</a>
                    </li>
                    {% endfor %}
                    {% else %}
                    <p>Pas de produits en favoris.</p>
                    {% endif %}
                </div>
            </div>
        </div>
    </div>
</section>
{% endblock content %}

compare/templates/compare/base.html
{% load static %}
<!DOCTYPE html>
<html lang="en">

<head>

  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <meta name="description" content="">
  <meta name="author" content="">

  <title>Purbeurre</title>

  <!-- Font Awesome Icons -->
  <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.8.1/css/all.css"
    integrity="sha384-50oBUHEmvpQ+1lW4y57PTFmhCaXp0ML5d60M1M7uH2+nqUivzIebhndOJK28anvf" crossorigin="anonymous">

  <!-- Google Fonts -->
  <link href="https://fonts.googleapis.com/css?family=Merriweather+Sans:400,700" rel="stylesheet">
  <link href='https://fonts.googleapis.com/css?family=Merriweather:400,300,300italic,400italic,700,700italic'
    rel='stylesheet' type='text/css'>
  <link href="https://fonts.googleapis.com/css?family=Open+Sans" rel="stylesheet" type="text/css">
  <link href="https://fonts.googleapis.com/css?family=Scope+One" rel="stylesheet" type="text/css">

  <!-- Plugin CSS -->
  <link href="{% static 'compare/theme/vendor/magnific-popup/magnific-popup.css' %}" rel="stylesheet">

  <!-- Theme CSS - Includes Bootstrap -->
  <link href="{% static 'compare/theme/css/creative.css' %}" rel="stylesheet">
  <link href="{% static 'compare/theme/css/custom.css' %}" rel="stylesheet">

  <link rel="apple-touch-icon" sizes="57x57" href="{% static 'compare/img/apple-icon-57x57.png' %}">
  <link rel="apple-touch-icon" sizes="60x60" href="{% static 'compare/img/apple-icon-60x60.png' %}">
  <link rel="apple-touch-icon" sizes="72x72" href="{% static 'compare/img/apple-icon-72x72.png' %}">
  <link rel="apple-touch-icon" sizes="76x76" href="{% static 'compare/img/apple-icon-76x76.png' %}">
  <link rel="apple-touch-icon" sizes="114x114" href="{% static 'compare/img/apple-icon-114x114.png' %}">
  <link rel="apple-touch-icon" sizes="120x120" href="{% static 'compare/img/apple-icon-120x120.png' %}">
  <link rel="apple-touch-icon" sizes="144x144" href="{% static 'compare/img/apple-icon-144x144.png' %}">
  <link rel="apple-touch-icon" sizes="152x152" href="{% static 'compare/img/apple-icon-152x152.png' %}">
  <link rel="apple-touch-icon" sizes="180x180" href="{% static 'compare/img/apple-icon-180x180.png' %}">
  <link rel="icon" type="image/png" sizes="192x192" href="{% static 'compare/img/android-icon-192x192.png' %}">
  <link rel="icon" type="image/png" sizes="32x32" href="{% static 'compare/img/favicon-32x32.png' %}">
  <link rel="icon" type="image/png" sizes="96x96" href="{% static 'compare/img/favicon-96x96.png' %}">
  <link rel="icon" type="image/png" sizes="16x16" href="{% static 'compare/img/favicon-16x16.png' %}">
  <link rel="icon" type="image/png" href="{% static 'compare/img/favicon.ico' %}">
  <link rel="manifest" href="{% static 'compare/img/manifest.json' %}">
  <meta name="msapplication-TileColor" content="#ffffff">
  <meta name="msapplication-TileImage" content="static/img/ms-icon-144x144.png">
  <meta name="theme-color" content="#ffffff">

</head>

<body id="page-top">

  {% include 'compare/menu.html' %}

  {% block content %}
  {% endblock content %}

  <!-- Footer -->
  <footer class="bg-light py-5">
    <div class="container">
      <div class="small text-center text-muted">Pur Beurre</div>
      <div class="small text-center text-muted"><a href="{% url 'compare:mentions' %}">Mentions légales</a></div>
    </div>
  </footer>

  <!-- Bootstrap core JavaScript -->
  <script src="{% static 'compare/theme/vendor/jquery/jquery.min.js'%}"></script>
  <script src="{% static 'compare/theme/vendor/bootstrap/js/bootstrap.bundle.min.js'%}"></script>

  <!-- Plugin JavaScript -->
  <script src="{% static 'compare/theme/vendor/jquery-easing/jquery.easing.min.js'%}"></script>
  <script src="{% static 'compare/theme/vendor/magnific-popup/jquery.magnific-popup.min.js'%}"></script>

  <!-- Custom scripts for this template -->
  <script src="{% static 'compare/theme/js/creative.min.js'%}"></script>

</body>

</html>

compare/templates/compare/details.html
{% extends 'compare/base.html' %}
{% load static %}

{% block content %}

{% include 'compare/header.html' %}

<section class="page-section" id="services">
    <div class="container">

        <h2 class="text-center mt-0">
            {% if user_result %}
            {{ user_result }}
            {% else %}
            Vous pouvez remplacer {{ product_selected.product_name }} par :
            {% endif %}
        </h2>

        <hr class="divider my-4">
        <div class="row justify-content-center">
            <div class="col-lg-12 col-md-10 ">
                <div class="mt-5">

                    {% if product %}
                    <div class="container">
                        <div class="row justify-content-center">
                    {% for p in product %}
                            <div class="col-lg-4 col-md-12">
                                <ul>
                                    <div class="img-container">
                                        <img src="{{ p.image_url}}" class="img-t">
                                        {% with 'compare/img/'|add:p.nutrition_grade_fr|add:'.png' as image_grade %}
                                        <img src="{% static image_grade %}" class="logo">
                                        {% endwith %}
                                    </div>
                                    <li><a href="{% url 'compare:product' p.id_product %}">{{ p.product_name }}</a>
                                    </li>
                                    <li>Calories : {{ p.kcal }}</li>
                                    <li><a href="{{ p.url }}" target="_blank">Fiche du produit OpenFoodFacts</a>
                                    </li>
                                    {% include 'compare/form_bookmark.html' %}
                                </ul>
                            </div>
                            {% endfor %}

                            {% elif user_result %}
                            <div class="col-lg-12 col-md-12">
                                {% include 'compare/form_search.html' %}
                            </div>
                            {% else %}
                            <div class="col-lg-6 col-md-12">
                                <p>Pas de résultats !</p>
                            </div>
                            {% endif %}
                        </div>
                    </div>
                </div>
            </div>
</section>

{% endblock content %}

compare/templates/compare/form_bookmark.html
<li>
    <form action="{% url 'compare:bookmark' p.id_product %}" method="post">
        {% csrf_token %}
        <div class="input-group-btn">
            Ajouter aux favoris :
            <button class="btn btn-default" type="submit">
                <i class="far fa-bookmark"></i>
            </button>
        </div>
        {% if next %}
        <input type="hidden" name="next" value="{{ next }}">
        {% else %}
        <input type="hidden" name="next" value="">
        {% endif %}
    </form>
</li>

compare/templates/compare/form_search.html
{% block content %}
<script src="http://ajax.googleapis.com/ajax/libs/jquery/2.1.0/jquery.min.js"></script>
<script type="text/javascript">
    $(document).ready(function () {
        $('#btnsearch').click(function () {
            checked = $(".user-filter input[type=checkbox]:checked").length;
            if (!checked) {
                $(".atleastone").html("Au moins un élément doit être coché !");
                return false;
            }
            $(".atleastone").remove()
        });
    });
</script>
<form action="{% url 'compare:results' %}" method="post">
    {% csrf_token %}
    <div class="form-group text-center">
        <div class="input-group mb-3">
            <input pattern=".{3,}" required title="Minimum trois caractères !" type="text" class="form-control"
                placeholder="Chercher un produit" name="product" aria-label="Chercher un produit"
                aria-describedby="basic-addon2">
            <div class="input-group-append">
                <button class="btn btn-outline-secondary" type="submit" id="btnsearch">Chercher</button>
            </div>

        </div>
        {% if '/details/' in request.path %}
        <div class="font-weight-light user-filter">
        {% else %}
        <div class="text-white-75 font-weight-light user-filter">
        {% endif %}
            <input type="checkbox" id="grade" name="grade" value="grade">
            <label for="grade">Nutriscore</label>
            <input type="checkbox" id="energy" name="energy" value="energy">
            <label for="energy">Calories</label>
            <p class='atleastone'></p>
        </div>
    </div>
</form>
{% endblock content %}

compare/templates/compare/form_signin.html
{% extends 'compare/base.html' %}

{% block content %}

{% include 'compare/header.html' %}

<section class="page-section" id="services">
    <div class="container">
        <h2 class="text-center mt-0">Connectez-vous !</h2>
        <hr class="divider my-4">
        <div class="row justify-content-center">
            <div class="col-lg-7 col-md col-sm">
                <div class="mt-5">

                    {% if user_result %}
                    {{ user_result }}
                    {% endif %}

                    {% if user.is_authenticated %}
                    <p>Vous êtes connecté⋅e.</p>
                    {% else %}
                    <p>Entrez votre adresse email et votre mot de passe pour vous connecter.</p>
                    {% if form.errors %}
                    {% for field in form %}
                    {% for error in field.errors %}
                    <div class="alert alert-danger">
                        <strong>{{ error|escape }}</strong>
                    </div>
                    {% endfor %}
                    {% endfor %}
                    {% for error in form.non_field_errors %}
                    <div class="alert alert-danger">
                        <strong>{{ error|escape }}</strong>
                    </div>
                    {% endfor %}
                    {% endif %}

                    {% if next %}
                    <form action="{% url 'compare:signin' %}?next={{next}}" method="post">
                        {% else %}
                        <form action="{% url 'compare:signin' %}" method="post">
                            {% endif %}
                            {% csrf_token %}

                            <div class="form-group row">

                                <label for="{{ form.email.id_for_label }}" class="col-sm-3 col-form-label">Email</label>
                                <div class="col-sm-8">
                                    {{ form.email}}
                                </div>

                                <label for="{{ form.password.id_for_label }}" class="col-sm-3 col-form-label">Mot de
                                    passe</label>
                                <div class="col-sm-8">
                                    {{ form.password}}
                                </div>

                            </div>

                            <div class="form-group row">
                                <div class="col-sm-2 offset-md-3">
                                    <button type="submit" class="btn btn-success">Valider</button>
                                    <input type="hidden" name="next" value="{{ next }}" </div> </div> </form>
                                        {% endif %} </div> </div> </div> </div> </div> </div> </section>
                                        {% endblock content %}

compare/templates/compare/form_signup.html
{% extends 'compare/base.html' %}

{% block content %}

{% include 'compare/header.html' %}

<section class="page-section" id="services">
    <div class="container">
        <h2 class="text-center mt-0">Création de compte.</h2>
        <hr class="divider my-4">
        <div class="row justify-content-center">
            <div class="col-lg-7 col-md col-sm">
                <div class="mt-5">

                    {% if user_result %}
                    {{ user_result }}
                    {% endif %}

                    {% if user.is_authenticated %}
                    Vous êtes connecté⋅e.
                    {% else %}
                    {{ next }}
                    <p>Entrez votre adresse email et un mot de passe pour créer un compte.</p>
                    {% if form.errors %}
                    {% for field in form %}
                    {% for error in field.errors %}
                    <div class="alert alert-danger">
                        <strong>{{ error|escape }}</strong>
                    </div>
                    {% endfor %}
                    {% endfor %}
                    {% for error in form.non_field_errors %}
                    <div class="alert alert-danger">
                        <strong>{{ error|escape }}</strong>
                    </div>
                    {% endfor %}
                    {% endif %}

                    {% if next %}
                    <form action="{% url 'compare:signup' %}?next={{next}}" method="post">
                        {% else %}
                        <form action="{% url 'compare:signup' %}" method="post">
                            {% endif %}

                            {% csrf_token %}
                            <div class="form-group row">
                                <label for="{{ form.email.id_for_label }}" class="col-sm-3 col-form-label">Email</label>
                                <div class="col-sm-8">
                                    {{ form.email}}
                                </div>

                                <label for="{{ form.password.id_for_label }}" class="col-sm-3 col-form-label">Mot de
                                    passe</label>
                                <div class="col-sm-8">
                                    {{ form.password}}
                                </div>
                            </div>
                            <div class="form-group row">
                                <div class="col-sm-2 offset-md-3">
                                    <button type="submit" class="btn btn-success">Valider</button>
                                    <input type="hidden" name="next" value="{{ next }}" </div> </div> </form>
                                        {% endif %} </div> </div> </div> </div> </section>
{% endblock content %}

compare/templates/compare/header.html
{% load static %}

{% if exception %}

<!-- Masthead -->
<header class="masthead_custom"
    style="background: linear-gradient(to bottom, rgba(92, 77, 66, 0.8) 0%, rgba(92, 77, 66, 0.8) 100%), url({% static  'compare/theme/img/bg-olenka-kotyk-unsplash.jpg' %})">
</header>

{% else %}

<!-- Masthead -->
{% with 'compare/theme/img/'|add:background as image_static %}
<header class="masthead_custom"
    style="background: linear-gradient(to bottom, rgba(92, 77, 66, 0.8) 0%, rgba(92, 77, 66, 0.8) 100%), url({% static image_static %})">
{% endwith %}
</header>

{% endif %}

compare/templates/compare/index.html
{% extends 'compare/base.html' %}
{% load static %}

{% block content %}

      <!-- Masthead -->
  {% with 'compare/theme/img/'|add:background as image_static %}
  <header class="masthead" style="background: linear-gradient(to bottom, rgba(92, 77, 66, 0.8) 0%, rgba(92, 77, 66, 0.8) 100%), url({% static image_static %})">
  {% endwith %}
    <div class="container h-100">
      <div class="row h-100 align-items-center justify-content-center text-center">
        <div class="col-lg-10 align-self-end">
          <h1 class="text-uppercase text-white font-weight-bold">Du gras, oui, mais de qualité !</h1>
          <hr class="divider my-4">
        </div>
        <div class="col-lg-8 align-self-baseline">
          <p class="text-white-75 font-weight-light mb-5">Pur Beurre est l'initiative de deux amoureux de la gastronomie française, Colette Tatou et Rémy, que vous avez déjà certainement rencontrés dans notre excellent restaurant Ratatouille.</p>
          <a class="btn btn-primary btn-xl js-scroll-trigger" href="#about">En savoir plus</a>
        </div>
      </div>
    </div>
  </header>
  
    <!-- About Section -->
  <section class="page-section bg-primary" id="about">
    <div class="container">
      <div class="row justify-content-center">
        <div class="col-lg-8 text-center">
          <h2 class="text-white mt-0">Trouvez de meilleurs produits !</h2>
          <hr class="divider light my-4">
                <p class="text-white-75 font-weight-light mb-5">Grâce à ce service, vous pouvez dès à présent trouver un substitut à un produit !</p>
          {% include 'compare/form_search.html' %}

        </div>
      </div>
    </div>
  </section>

    <!-- Contact Section -->
  <section class="page-section" id="contact">
    <div class="container">
      <div class="row justify-content-center">
        <div class="col-lg-8 text-center">
          <h2 class="mt-0">Restons en contact !</h2>
          <hr class="divider my-4">
          <p class="text-muted mb-5">Une suggestion? Une question? Nous accueillerons vos messages avec plaisir !</p>
        </div>
      </div>
      <div class="row">
        <div class="col-lg-4 ml-auto text-center">
          <i class="fas fa-phone fa-3x mb-3 text-muted"></i>
          <div>0102030405</div>
        </div>
        <div class="col-lg-4 mr-auto text-center">
          <i class="fas fa-envelope fa-3x mb-3 text-muted"></i>
          <!-- Make sure to change the email address in anchor text AND the link below! -->
          <a class="d-block" href="mailto:contact@beurre.pur">contact@beurre.pur</a>
        </div>
      </div>
    </div>
  </section>

{% endblock content %}

compare/templates/compare/menu.html
  {% load static %}
  <nav class="navbar navbar-expand-lg navbar-light fixed-top py-3" id="mainNav">
    <div class="container">
      <a class="navbar-brand js-scroll-trigger" href="{% url 'compare:index' %}">
      <img height="50px" src="{% static 'compare/theme/img/logo_pur_beurre.png' %}"
     alt="Logo de Pur Beurre" title="Pur Beurre" />
      Pur Beurre
      </a>
      <button class="navbar-toggler navbar-toggler-right" type="button" data-toggle="collapse" data-target="#navbarResponsive" aria-controls="navbarResponsive" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
      </button>
      <div class="collapse navbar-collapse" id="navbarResponsive">
        <ul class="navbar-nav ml-auto my-2 my-lg-0">
        {% if request.path == '/compare/' %}
        {% endif %}

            {% if user.is_authenticated %}
                <li class="nav-item">
                    <a class="nav-link js-scroll-trigger" href="{% url 'compare:account'%}">
                    <i class="fas fa-carrot"></i>
                    </a>
                </li>
                <li class="nav-item">
                    <a class="nav-link js-scroll-trigger" href="{% url 'compare:signout'%}">
                    <i class="fas fa-sign-out-alt"></i>
                    </a>
                </li>
            {% else %}
                <li class="nav-item">
                    <a class="nav-link js-scroll-trigger" href="{% url 'compare:signin'%}">
                    <i class="fas fa-carrot"></i>
                    </a>
                </li>
                <li class="nav-item">
                    <a class="nav-link js-scroll-trigger" href="{% url 'compare:signup'%}">
                    <i class="fas fa-user-plus"></i>
                    </a>
                </li>
            {% endif %}
        </ul>
      </div>
    </div>
  </nav>

compare/templates/compare/results.html
{% extends 'compare/base.html' %}

{% block content %}

{% include 'compare/header.html' %}

<!-- Services Section -->
<section class="page-section" id="services">
    <div class="container">
        <h2 class="text-center mt-0">Résultats de la recherche</h2>
        <hr class="divider my-4">
        <div class="row justify-content-center">
            <div class="col-lg-10 col-md-12 ">
                <div class="mt-5">

                    {% if query %}
                    <ul>
                        {% for product in query %}
                        <li>
                            <a href="{% url 'compare:details' product.id_product %}">
                                {{ product.product_name }} - {{ product.brands }}</a>
                        </li>
                        {% endfor %}
                    </ul>
                    {% else %}
                    <p>Pas de produits trouvés.</p>
                    {% endif %}

                </div>
            </div>
        </div>
    </div>
</section>

{% endblock content %}

compare/templates/compare/signout.html
{% extends 'compare/base.html' %}

{% block content %}
    {{ user_result }}
{% endblock content %}